/*
 * aTunes 1.13.6
 * Copyright (C) 2006-2009 Alex Aranda, Sylvain Gaudard, Thomas Beckers and contributors
 *
 * See http://www.atunes.org/wiki/index.php?title=Contributing for information about contributors
 *
 * http://www.atunes.org
 * http://sourceforge.net/projects/atunes
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

package net.sourceforge.atunes.gui.views.menu;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JSeparator;

import net.sourceforge.atunes.kernel.actions.Actions;
import net.sourceforge.atunes.kernel.actions.Add100RandomSongsAction;
import net.sourceforge.atunes.kernel.actions.Add100SongsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.Add100UnplayedSongsAction;
import net.sourceforge.atunes.kernel.actions.Add10AlbumsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.Add10ArtistsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.Add10RandomSongsAction;
import net.sourceforge.atunes.kernel.actions.Add10SongsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.Add10UnplayedSongsAction;
import net.sourceforge.atunes.kernel.actions.Add1AlbumsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.Add1ArtistsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.Add50RandomSongsAction;
import net.sourceforge.atunes.kernel.actions.Add50SongsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.Add50UnplayedSongsAction;
import net.sourceforge.atunes.kernel.actions.Add5AlbumsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.Add5ArtistsMostPlayedAction;
import net.sourceforge.atunes.kernel.actions.AddPodcastFeedAction;
import net.sourceforge.atunes.kernel.actions.AddRadioAction;
import net.sourceforge.atunes.kernel.actions.AutoSetCoversAction;
import net.sourceforge.atunes.kernel.actions.AutoSetGenresAction;
import net.sourceforge.atunes.kernel.actions.AutoSetLyricsAction;
import net.sourceforge.atunes.kernel.actions.AutoSetTagFromFileNamePatternAction;
import net.sourceforge.atunes.kernel.actions.AutoSetTitlesAction;
import net.sourceforge.atunes.kernel.actions.AutoSetTracksAction;
import net.sourceforge.atunes.kernel.actions.CheckUpdatesAction;
import net.sourceforge.atunes.kernel.actions.ClearPlayListAction;
import net.sourceforge.atunes.kernel.actions.CollapseTreesAction;
import net.sourceforge.atunes.kernel.actions.ConnectDeviceAction;
import net.sourceforge.atunes.kernel.actions.CreatePlayListWithSelectedAlbumsAction;
import net.sourceforge.atunes.kernel.actions.CreatePlayListWithSelectedArtistsAction;
import net.sourceforge.atunes.kernel.actions.CustomSearchAction;
import net.sourceforge.atunes.kernel.actions.DisconnectDeviceAction;
import net.sourceforge.atunes.kernel.actions.EditPreferencesAction;
import net.sourceforge.atunes.kernel.actions.EditTagAction;
import net.sourceforge.atunes.kernel.actions.ExitAction;
import net.sourceforge.atunes.kernel.actions.ExpandTreesAction;
import net.sourceforge.atunes.kernel.actions.ExportAction;
import net.sourceforge.atunes.kernel.actions.FilterNavigatorAction;
import net.sourceforge.atunes.kernel.actions.FullScreenAction;
import net.sourceforge.atunes.kernel.actions.ImportLovedTracksFromLastFM;
import net.sourceforge.atunes.kernel.actions.ImportToRepositoryAction;
import net.sourceforge.atunes.kernel.actions.LoadPlayListAction;
import net.sourceforge.atunes.kernel.actions.MoveDownAction;
import net.sourceforge.atunes.kernel.actions.MoveToBottomAction;
import net.sourceforge.atunes.kernel.actions.MoveToTopAction;
import net.sourceforge.atunes.kernel.actions.MoveUpAction;
import net.sourceforge.atunes.kernel.actions.MuteAction;
import net.sourceforge.atunes.kernel.actions.OpenFolderAction;
import net.sourceforge.atunes.kernel.actions.PlayAction;
import net.sourceforge.atunes.kernel.actions.RefreshDeviceAction;
import net.sourceforge.atunes.kernel.actions.RefreshRepositoryAction;
import net.sourceforge.atunes.kernel.actions.RemoveFromPlayListAction;
import net.sourceforge.atunes.kernel.actions.RepairAlbumNamesAction;
import net.sourceforge.atunes.kernel.actions.RepairGenresAction;
import net.sourceforge.atunes.kernel.actions.RepairTrackNumbersAction;
import net.sourceforge.atunes.kernel.actions.ReportBugOrFeatureRequestAction;
import net.sourceforge.atunes.kernel.actions.RipCDAction;
import net.sourceforge.atunes.kernel.actions.SavePlayListAction;
import net.sourceforge.atunes.kernel.actions.SelectRepositoryAction;
import net.sourceforge.atunes.kernel.actions.SetPlayListSelectionAsFavoriteAlbumAction;
import net.sourceforge.atunes.kernel.actions.SetPlayListSelectionAsFavoriteArtistAction;
import net.sourceforge.atunes.kernel.actions.SetPlayListSelectionAsFavoriteSongAction;
import net.sourceforge.atunes.kernel.actions.ShowAboutAction;
import net.sourceforge.atunes.kernel.actions.ShowAlbumsInNavigatorAction;
import net.sourceforge.atunes.kernel.actions.ShowArtistsInNavigatorAction;
import net.sourceforge.atunes.kernel.actions.ShowAudioObjectPropertiesAction;
import net.sourceforge.atunes.kernel.actions.ShowContextAction;
import net.sourceforge.atunes.kernel.actions.ShowCoverNavigatorAction;
import net.sourceforge.atunes.kernel.actions.ShowDeviceViewAction;
import net.sourceforge.atunes.kernel.actions.ShowEqualizerAction;
import net.sourceforge.atunes.kernel.actions.ShowFavoritesViewAction;
import net.sourceforge.atunes.kernel.actions.ShowFoldersInNavigatorAction;
import net.sourceforge.atunes.kernel.actions.ShowGenresInNavigatorAction;
import net.sourceforge.atunes.kernel.actions.ShowLogAction;
import net.sourceforge.atunes.kernel.actions.ShowNavigationTableAction;
import net.sourceforge.atunes.kernel.actions.ShowNavigatorAction;
import net.sourceforge.atunes.kernel.actions.ShowOSDAction;
import net.sourceforge.atunes.kernel.actions.ShowPlayListControlsAction;
import net.sourceforge.atunes.kernel.actions.ShowPlayListItemInfoAction;
import net.sourceforge.atunes.kernel.actions.ShowPodcastViewAction;
import net.sourceforge.atunes.kernel.actions.ShowRadioBrowserAction;
import net.sourceforge.atunes.kernel.actions.ShowRadioViewAction;
import net.sourceforge.atunes.kernel.actions.ShowRepositoryViewAction;
import net.sourceforge.atunes.kernel.actions.ShowStatsAction;
import net.sourceforge.atunes.kernel.actions.ShowStatusBarAction;
import net.sourceforge.atunes.kernel.actions.ShowToolbarAction;
import net.sourceforge.atunes.kernel.actions.ShufflePlayListAction;
import net.sourceforge.atunes.kernel.actions.SortNavigatorByArtistAndAlbumAction;
import net.sourceforge.atunes.kernel.actions.SortNavigatorByFileNameAction;
import net.sourceforge.atunes.kernel.actions.SortNavigatorByModificationDateAction;
import net.sourceforge.atunes.kernel.actions.SortNavigatorByTitleAction;
import net.sourceforge.atunes.kernel.actions.SortNavigatorByTrackNumberAction;
import net.sourceforge.atunes.kernel.actions.TogglePlayListFilterAction;
import net.sourceforge.atunes.kernel.actions.VolumeDownAction;
import net.sourceforge.atunes.kernel.actions.VolumeUpAction;
import net.sourceforge.atunes.kernel.modules.player.PlayerEngineCapability;
import net.sourceforge.atunes.kernel.modules.player.PlayerHandler;
import net.sourceforge.atunes.utils.LanguageTool;

/**
 * The Class ApplicationMenuBar.
 */
public class ApplicationMenuBar extends JMenuBar {

    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = 234977404080329591L;

    /** The file. */
    private JMenu file;

    /** The edit. */
    private JMenu edit;

    /** The view. */
    private JMenu view;

    /** The navigator */
    private JMenu navigator;

    /** The play list. */
    private JMenu playList;

    /** The tools. */
    private JMenu tools;

    /** The device. */
    private JMenu device;

    /** The about. */
    private JMenu about;

    /**
     * Instantiates a new application menu bar.
     */
    public ApplicationMenuBar() {
        super();
        addMenus();
    }

    /**
     * Creates "File" menu
     * 
     * @return
     */
    private JMenu getFileMenu() {
        if (file == null) {
            file = new JMenu(LanguageTool.getString("FILE"));
            file.add(Actions.getAction(SelectRepositoryAction.class));
            file.add(Actions.getAction(RefreshRepositoryAction.class));
            file.add(new JSeparator());
            file.add(Actions.getAction(ImportToRepositoryAction.class));
            file.add(Actions.getAction(ExportAction.class));
            file.add(new JSeparator());
            file.add(Actions.getAction(ExitAction.class));
        }
        return file;
    }

    /**
     * Creates "Edit" menu
     * 
     * @return
     */
    private JMenu getEditMenu() {
        if (edit == null) {
            edit = new JMenu(LanguageTool.getString("EDIT"));
            JMenu player = new JMenu(LanguageTool.getString("VOLUME"));
            JMenuItem showEqual = new JMenuItem(Actions.getAction(ShowEqualizerAction.class));
            player.add(showEqual);
            if (!PlayerHandler.getInstance().supportsCapability(PlayerEngineCapability.EQUALIZER)) {
                showEqual.setEnabled(false);
            }
            player.add(Actions.getAction(VolumeUpAction.class));
            player.add(Actions.getAction(VolumeDownAction.class));
            player.add(Actions.getAction(MuteAction.class));
            JMenu repair = new JMenu(LanguageTool.getString("REPAIR"));
            repair.add(Actions.getAction(RepairTrackNumbersAction.class));
            repair.add(Actions.getAction(RepairGenresAction.class));
            repair.add(Actions.getAction(RepairAlbumNamesAction.class));
            edit.add(player);
            edit.add(Actions.getAction(EditPreferencesAction.class));
            edit.add(new JSeparator());
            edit.add(repair);
        }
        return edit;
    }

    /**
     * Creates "View" menu
     * 
     * @return
     */
    private JMenu getViewMenu() {
        if (view == null) {
            view = new JMenu(LanguageTool.getString("VIEW"));
            view.add(Actions.getAction(ShowRepositoryViewAction.class));
            view.add(Actions.getAction(ShowFavoritesViewAction.class));
            view.add(Actions.getAction(ShowDeviceViewAction.class));
            view.add(Actions.getAction(ShowRadioViewAction.class));
            view.add(Actions.getAction(ShowPodcastViewAction.class));
            view.add(new JSeparator());
            view.add(new JCheckBoxMenuItem(Actions.getAction(ShowToolbarAction.class)));
            view.add(new JCheckBoxMenuItem(Actions.getAction(ShowStatusBarAction.class)));
            view.add(new JCheckBoxMenuItem(Actions.getAction(ShowPlayListControlsAction.class)));
            view.add(new JCheckBoxMenuItem(Actions.getAction(ShowNavigatorAction.class)));
            view.add(new JCheckBoxMenuItem(Actions.getAction(ShowNavigationTableAction.class)));
            view.add(new JCheckBoxMenuItem(Actions.getAction(ShowAudioObjectPropertiesAction.class)));
            view.add(new JCheckBoxMenuItem(Actions.getAction(ShowContextAction.class)));
            view.add(new JCheckBoxMenuItem(Actions.getAction(ShowOSDAction.class)));
            view.add(new JSeparator());
            view.add(Actions.getAction(FullScreenAction.class));
        }
        return view;
    }

    /**
     * Creates "Navigator" menu
     * 
     * @return
     */
    private JMenu getNavigatorMenu() {
        if (navigator == null) {
            navigator = new JMenu(LanguageTool.getString("NAVIGATOR"));
            JRadioButtonMenuItem showArtist = new JRadioButtonMenuItem(Actions.getAction(ShowArtistsInNavigatorAction.class));
            JRadioButtonMenuItem showAlbum = new JRadioButtonMenuItem(Actions.getAction(ShowAlbumsInNavigatorAction.class));
            JRadioButtonMenuItem showGenre = new JRadioButtonMenuItem(Actions.getAction(ShowGenresInNavigatorAction.class));
            JRadioButtonMenuItem showFolder = new JRadioButtonMenuItem(Actions.getAction(ShowFoldersInNavigatorAction.class));
            ButtonGroup group = new ButtonGroup();
            group.add(showArtist);
            group.add(showAlbum);
            group.add(showGenre);
            group.add(showFolder);
            navigator.add(showArtist);
            navigator.add(showAlbum);
            navigator.add(showGenre);
            navigator.add(showFolder);
            navigator.add(new JSeparator());
            navigator.add(Actions.getAction(ExpandTreesAction.class));
            navigator.add(Actions.getAction(CollapseTreesAction.class));
            navigator.add(new JSeparator());
            JRadioButtonMenuItem sortByTrack = new JRadioButtonMenuItem(Actions.getAction(SortNavigatorByTrackNumberAction.class));
            JRadioButtonMenuItem sortByArtist = new JRadioButtonMenuItem(Actions.getAction(SortNavigatorByArtistAndAlbumAction.class));
            JRadioButtonMenuItem sortByTitle = new JRadioButtonMenuItem(Actions.getAction(SortNavigatorByTitleAction.class));
            JRadioButtonMenuItem sortByFile = new JRadioButtonMenuItem(Actions.getAction(SortNavigatorByFileNameAction.class));
            JRadioButtonMenuItem sortByModificationTime = new JRadioButtonMenuItem(Actions.getAction(SortNavigatorByModificationDateAction.class));
            ButtonGroup group2 = new ButtonGroup();
            group2.add(sortByTrack);
            group2.add(sortByArtist);
            group2.add(sortByTitle);
            group2.add(sortByFile);
            group2.add(sortByModificationTime);
            navigator.add(sortByTrack);
            navigator.add(sortByArtist);
            navigator.add(sortByTitle);
            navigator.add(sortByFile);
            navigator.add(sortByModificationTime);
            navigator.add(new JSeparator());
            navigator.add(Actions.getAction(FilterNavigatorAction.class));
        }
        return navigator;
    }

    /**
     * Creates "Playlist" menu
     * 
     * @return
     */
    private JMenu getPlayListMenu() {
        if (playList == null) {
            playList = new JMenu(LanguageTool.getString("PLAYLIST"));
            playList.add(Actions.getAction(PlayAction.class));
            playList.add(Actions.getAction(ShowPlayListItemInfoAction.class));
            playList.add(new JSeparator());
            playList.add(Actions.getAction(OpenFolderAction.class));
            playList.add(new JSeparator());
            JMenu playListTags = new JMenu(LanguageTool.getString("TAGS"));
            playListTags.add(Actions.getAction(EditTagAction.class));
            playListTags.add(new JSeparator());
            playListTags.add(Actions.getAction(AutoSetTagFromFileNamePatternAction.class));
            playListTags.add(new JSeparator());
            playListTags.add(Actions.getAction(AutoSetLyricsAction.class));
            playListTags.add(Actions.getAction(AutoSetTitlesAction.class));
            playListTags.add(Actions.getAction(AutoSetTracksAction.class));
            playListTags.add(Actions.getAction(AutoSetGenresAction.class));
            playListTags.add(Actions.getAction(AutoSetCoversAction.class));
            playList.add(playListTags);
            playList.add(new JSeparator());
            playList.add(Actions.getAction(SavePlayListAction.class));
            playList.add(Actions.getAction(LoadPlayListAction.class));
            playList.add(new JSeparator());
            playList.add(Actions.getAction(RemoveFromPlayListAction.class));
            playList.add(Actions.getAction(ClearPlayListAction.class));
            playList.add(new JSeparator());
            playList.add(Actions.getAction(MoveToTopAction.class));
            playList.add(Actions.getAction(MoveUpAction.class));
            playList.add(Actions.getAction(MoveDownAction.class));
            playList.add(Actions.getAction(MoveToBottomAction.class));
            playList.add(new JSeparator());
            playList.add(Actions.getAction(ShufflePlayListAction.class));
            playList.add(new JSeparator());
            JMenu smartPlayList = new JMenu(LanguageTool.getString("SMART_PLAYLIST"));
            smartPlayList.add(Actions.getAction(Add10RandomSongsAction.class));
            smartPlayList.add(Actions.getAction(Add50RandomSongsAction.class));
            smartPlayList.add(Actions.getAction(Add100RandomSongsAction.class));
            smartPlayList.add(new JSeparator());
            smartPlayList.add(Actions.getAction(Add10SongsMostPlayedAction.class));
            smartPlayList.add(Actions.getAction(Add50SongsMostPlayedAction.class));
            smartPlayList.add(Actions.getAction(Add100SongsMostPlayedAction.class));
            smartPlayList.add(new JSeparator());
            smartPlayList.add(Actions.getAction(Add1AlbumsMostPlayedAction.class));
            smartPlayList.add(Actions.getAction(Add5AlbumsMostPlayedAction.class));
            smartPlayList.add(Actions.getAction(Add10AlbumsMostPlayedAction.class));
            smartPlayList.add(new JSeparator());
            smartPlayList.add(Actions.getAction(Add1ArtistsMostPlayedAction.class));
            smartPlayList.add(Actions.getAction(Add5ArtistsMostPlayedAction.class));
            smartPlayList.add(Actions.getAction(Add10ArtistsMostPlayedAction.class));
            smartPlayList.add(new JSeparator());
            smartPlayList.add(Actions.getAction(Add10UnplayedSongsAction.class));
            smartPlayList.add(Actions.getAction(Add50UnplayedSongsAction.class));
            smartPlayList.add(Actions.getAction(Add100UnplayedSongsAction.class));
            playList.add(smartPlayList);
            playList.add(new JSeparator());
            playList.add(Actions.getAction(SetPlayListSelectionAsFavoriteSongAction.class));
            playList.add(Actions.getAction(SetPlayListSelectionAsFavoriteAlbumAction.class));
            playList.add(Actions.getAction(SetPlayListSelectionAsFavoriteArtistAction.class));
            playList.add(new JSeparator());
            playList.add(Actions.getAction(CreatePlayListWithSelectedArtistsAction.class));
            playList.add(Actions.getAction(CreatePlayListWithSelectedAlbumsAction.class));
            playList.add(new JSeparator());
            playList.add(Actions.getAction(TogglePlayListFilterAction.class));
        }
        return playList;
    }

    /**
     * Creates "Tools" menu
     * 
     * @return
     */
    private JMenu getToolsMenu() {
        if (tools == null) {
            tools = new JMenu(LanguageTool.getString("TOOLS"));
            tools.add(Actions.getAction(RipCDAction.class));
            tools.add(new JSeparator());
            tools.add(Actions.getAction(ShowStatsAction.class));
            tools.add(Actions.getAction(ShowCoverNavigatorAction.class));
            tools.add(new JSeparator());
            tools.add(Actions.getAction(AddRadioAction.class));
            tools.add(Actions.getAction(ShowRadioBrowserAction.class));
            tools.add(Actions.getAction(AddPodcastFeedAction.class));
            tools.add(new JSeparator());
            tools.add(Actions.getAction(CustomSearchAction.class));
            tools.add(new JSeparator());
            tools.add(Actions.getAction(ImportLovedTracksFromLastFM.class));
        }
        return tools;
    }

    /**
     * Creates "Device" menu
     * 
     * @return
     */
    private JMenu getDeviceMenu() {
        if (device == null) {
            device = new JMenu(LanguageTool.getString("DEVICE"));
            device.add(Actions.getAction(ConnectDeviceAction.class));
            device.add(Actions.getAction(RefreshDeviceAction.class));
            device.add(Actions.getAction(DisconnectDeviceAction.class));
        }
        return device;
    }

    /**
     * Creates "About" menu
     * 
     * @return
     */
    private JMenu getAboutMenu() {
        if (about == null) {
            about = new JMenu(LanguageTool.getString("ABOUT"));
            about.add(Actions.getAction(CheckUpdatesAction.class));
            about.add(Actions.getAction(ReportBugOrFeatureRequestAction.class));
            about.add(Actions.getAction(ShowLogAction.class));
            about.add(new JSeparator());
            about.add(Actions.getAction(ShowAboutAction.class));
        }
        return about;
    }

    /**
     * Adds the menus.
     */
    private void addMenus() {
        add(getFileMenu());
        add(getEditMenu());
        add(getViewMenu());
        add(getNavigatorMenu());
        add(getPlayListMenu());
        add(getDeviceMenu());
        add(getToolsMenu());
        add(getAboutMenu());
    }
}
