/*
 * aTunes 1.13.6
 * Copyright (C) 2006-2009 Alex Aranda, Sylvain Gaudard, Thomas Beckers and contributors
 *
 * See http://www.atunes.org/wiki/index.php?title=Contributing for information about contributors
 *
 * http://www.atunes.org
 * http://sourceforge.net/projects/atunes
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

package net.sourceforge.atunes.kernel.modules.player.vlcplayer;

import java.io.File;

import net.sourceforge.atunes.kernel.ControllerProxy;
import net.sourceforge.atunes.kernel.modules.podcast.PodcastFeedEntry;
import net.sourceforge.atunes.kernel.modules.repository.audio.AudioFile;

/**
 * The Class PodcastFeedEntryMPlayerOutputReader.
 */
class PodcastFeedEntryVlcPlayerOutputReader extends VlcPlayerOutputReader {

    /** The podcast feed entry. */
    private PodcastFeedEntry podcastFeedEntry;

    /**
     * Instantiates a new podcast feed entry m player output reader.
     * 
     * @param handler
     *            the handler
     * @param process
     *            the process
     * @param podcastFeedEntry
     *            the podcast feed entry
     */
    PodcastFeedEntryVlcPlayerOutputReader(VlcPlayerHandler handler, PodcastFeedEntry podcastFeedEntry) {
        super(handler);
        this.podcastFeedEntry = podcastFeedEntry;
    }

    @Override
    protected void init() {
        super.init();
        handler.setCurrentLength(podcastFeedEntry.getDuration() * 1000);

        //it's reasonable to enable the slide bar if playing
        //feed entry is a valid audio file, even if it was not downloaded  
        if (AudioFile.isValidAudioFile(new File(podcastFeedEntry.getUrl()))) {
            ControllerProxy.getInstance().getPlayerControlsController().setSlidable(true);
        }
    }

    @Override
    protected void read(String line) {
        super.read(line);
    }

}
